com.io7m.jtensors

## Class MatrixM3x3D

- java.lang.Object
- - com.io7m.jtensors.MatrixM3x3D

- All Implemented Interfaces:
    MatrixReadable3x3DType, MatrixReadableDType

      public class MatrixM3x3D
      extends Object
      implements MatrixReadable3x3DType

  A 3x3 mutable matrix type with double precision elements.

  Values of type `MatrixM3x3D` are backed by direct memory, with the rows and columns of the matrices being stored in column-major format. This allows the matrices to be passed to OpenGL directly, without requiring transposition.

  Values of this type cannot be accessed safely from multiple threads without explicit synchronization.

  See "Mathematics for 3D Game Programming and Computer Graphics" 2nd Ed for the derivations of most of the code in this class (ISBN: 1-58450-277-0).

  See Elementary operations for the three elementary operations defined on matrices.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `MatrixM3x3D.Context` The Context type contains the minimum storage required for all of the functions of the `MatrixM3x3D` class.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MatrixM3x3D()` Construct a new identity matrix.
    `MatrixM3x3D(MatrixReadable3x3DType source)` Construct a new copy of the given matrix.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static MatrixM3x3D` | `add(MatrixReadable3x3DType m0, MatrixReadable3x3DType m1, MatrixM3x3D out)` Elementwise add of matrices `m0` and `m1`.
    `static MatrixM3x3D` | `addInPlace(MatrixM3x3D m0, MatrixM3x3D m1)` Elementwise add of matrices `m0` and `m1`, returning the result in `m0`.
    `static MatrixM3x3D` | `addRowScaled(MatrixReadable3x3DType m, int row_a, int row_b, int row_c, double r, MatrixM3x3D out)` Add the values in row `row_b` to the values in row `row_a` scaled by `r`, saving the resulting row in row `row_c` of the matrix `out`.
    `static MatrixM3x3D` | `addRowScaledInPlace(MatrixM3x3D m, int row_a, int row_b, int row_c, double r)` Add the values in row `row_b` to the values in row `row_a` scaled by `r`, saving the resulting row in row `row_c` of the matrix `m`.
    `static MatrixM3x3D` | `copy(MatrixReadable3x3DType input, MatrixM3x3D output)` Copy the contents of the matrix `input` to the matrix `output`, completely replacing all elements.
    `static double` | `determinant(MatrixReadable3x3DType m)` Calculate the determinant of the matrix `m`.
    `static DoubleBuffer` | `doubleBuffer(MatrixM3x3D m)`
    `boolean` | `equals(Object obj)`
    `static MatrixM3x3D` | `exchangeRows(MatrixReadable3x3DType m, int row_a, int row_b, MatrixM3x3D out)` Exchange the row `row_a` and row `row_b` of the matrix `m`, saving the exchanged rows to `out`.
    `static MatrixM3x3D` | `exchangeRowsInPlace(MatrixM3x3D m, int row_a, int row_b)` Exchange the row `row_a` and row `row_b` of the matrix `m`, saving the exchanged rows to `m`.
    `double` | `get(int row, int column)`
    `static double` | `get(MatrixReadable3x3DType m, int row, int column)`
    `DoubleBuffer` | `getDoubleBuffer()`
    `void` | `getRow3D(int row, VectorM3D out)` Retrieve row `row`, saving the result to `out`.
    `double` | `getRowColumnD(int row, int column)`
    `int` | `hashCode()`
    `static com.io7m.jfunctional.OptionType<MatrixM3x3D>` | `invert(MatrixReadable3x3DType m, MatrixM3x3D out)` Calculate the inverse of the matrix `m`, saving the resulting matrix to `out`.
    `static com.io7m.jfunctional.OptionType<MatrixM3x3D>` | `invertInPlace(MatrixM3x3D m)` Calculate the inverse of the matrix `m`, saving the resulting matrix to `m`.
    `static void` | `lookAtWithContext(MatrixM3x3D.Context context, VectorReadable3DType origin, VectorReadable3DType target, VectorReadable3DType up, MatrixM3x3D out_matrix, VectorM3D out_translation)` Calculate a rotation and translation representing a "camera" looking from the point `origin` to the point `target`.
    `static MatrixM3x3D` | `makeRotation(double angle, VectorReadable3DType axis)` Generate and return a matrix that represents a rotation of `angle` radians around the axis `axis`.
    `static MatrixM3x3D` | `makeRotation(double angle, VectorReadable3DType axis, MatrixM3x3D out)` Generate a matrix that represents a rotation of `angle` radians around the axis `axis` and save to `out`.
    `static MatrixM3x3D` | `makeTranslation2D(VectorReadable2DType v, MatrixM3x3D out)` Create a translation matrix that represents a translation by the vector `v`, writing the resulting matrix to `out`.
    `static MatrixM3x3D` | `makeTranslation2I(VectorReadable2IType v, MatrixM3x3D out)` Create a translation matrix that represents a translation by the vector `v`, writing the resulting matrix to `out`.
    `static MatrixM3x3D` | `multiply(MatrixReadable3x3DType m0, MatrixReadable3x3DType m1, MatrixM3x3D out)` Multiply the matrix `m0` with the matrix `m1`, writing the result to `out`.
    `static MatrixM3x3D` | `multiplyInPlace(MatrixM3x3D m0, MatrixReadable3x3DType m1)` Multiply the matrix `m0` with the matrix `m1`, writing the result to `m0`.
    `static VectorM3D` | `multiplyVector3D(MatrixReadable3x3DType m, VectorReadable3DType v, VectorM3D out)` Multiply the matrix `m` with the vector `v`, writing the resulting vector to `out`.
    `static MatrixM3x3D` | `rotate(double angle, MatrixReadable3x3DType m, VectorReadable3DType axis, MatrixM3x3D out)` Rotate the matrix `m` by `angle` radians around the axis `axis`, saving the result into `out`.
    `static MatrixM3x3D` | `rotateInPlace(double angle, MatrixM3x3D m, VectorReadable3DType axis)` Rotate the matrix `m` by `angle` radians around the axis `axis`, saving the result into `m`.
    `static MatrixM3x3D` | `rotateInPlaceWithContext(MatrixM3x3D.Context context, double angle, MatrixM3x3D m, VectorReadable3DType axis)` Rotate the matrix `m` by `angle` radians around the axis `axis`, saving the result into `m`.
    `static MatrixM3x3D` | `rotateWithContext(MatrixM3x3D.Context context, double angle, MatrixReadable3x3DType m, VectorReadable3DType axis, MatrixM3x3D out)` Rotate the matrix `m` by `angle` radians around the axis `axis`, saving the result into `out`.
    `static VectorM3D` | `row(MatrixReadable3x3DType m, int row, VectorM3D out)`
    `static MatrixM3x3D` | `scale(MatrixReadable3x3DType m, double r, MatrixM3x3D out)` Scale all elements of the matrix `m` by the scaling value `r`, saving the result in `out`.
    `static MatrixM3x3D` | `scaleInPlace(MatrixM3x3D m, double r)` Scale all elements of the matrix `m` by the scaling value `r`, saving the result in `m`.
    `static MatrixM3x3D` | `scaleRow(MatrixReadable3x3DType m, int row, double r, MatrixM3x3D out)` Scale row `r` of the matrix `m` by `r`, saving the result to row `r` of `out`.
    `static MatrixM3x3D` | `scaleRowInPlace(MatrixM3x3D m, int row, double r)` Scale row `r` of the matrix `m` by `r`, saving the result to row `r` of `m`.
    `MatrixM3x3D` | `set(int row, int column, double value)` Set the value at the given row and column.
    `static MatrixM3x3D` | `set(MatrixM3x3D m, int row, int column, double value)` Set the value in the matrix `m` at row `row`, column `column` to `value`.
    `static MatrixM3x3D` | `setIdentity(MatrixM3x3D m)` Set the given matrix `m` to the identity matrix.
    `static MatrixM3x3D` | `setZero(MatrixM3x3D m)` Set the given matrix `m` to the zero matrix.
    `String` | `toString()`
    `static double` | `trace(MatrixReadable3x3DType m)` Return the trace of the matrix `m`.
    `static MatrixM3x3D` | `translateByVector2D(MatrixReadable3x3DType m, VectorReadable2DType v, MatrixM3x3D out)` Translate the matrix `m` by the vector `v`, storing the resulting matrix in `out`.
    `static MatrixM3x3D` | `translateByVector2DInPlace(MatrixM3x3D m, VectorReadable2DType v)` Translate the matrix `m` by the vector `v`, storing the resulting matrix in `m`.
    `static MatrixM3x3D` | `translateByVector2I(MatrixReadable3x3DType m, VectorReadable2IType v, MatrixM3x3D out)` Translate the matrix `m` by the vector `v`, storing the resulting matrix in `out`.
    `static MatrixM3x3D` | `translateByVector2IInPlace(MatrixM3x3D m, VectorReadable2IType v)` Translate the matrix `m` by the vector `v`, storing the resulting matrix in `m`.
    `static MatrixM3x3D` | `transpose(MatrixReadable3x3DType m, MatrixM3x3D out)` Transpose the given matrix `m`, writing the resulting matrix to `out`.
    `static MatrixM3x3D` | `transposeInPlace(MatrixM3x3D m)` Transpose the given matrix `m`, writing the resulting matrix to `m`.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### MatrixM3x3D

          public MatrixM3x3D()

      Construct a new identity matrix.

    - #### MatrixM3x3D

          public MatrixM3x3D(MatrixReadable3x3DType source)

      Construct a new copy of the given matrix.
      Parameters:
        `source` - The source matrix.

  - ### Method Detail

    - #### add

          public static final MatrixM3x3D add(MatrixReadable3x3DType m0,
                                              MatrixReadable3x3DType m1,
                                              MatrixM3x3D out)

      Elementwise add of matrices `m0` and `m1`.
      Parameters:
        `m0` - The left input matrix.
        `m1` - The right input matrix.
        `out` - The output matrix.
      Returns:
        `out`

    - #### addInPlace

          public static final MatrixM3x3D addInPlace(MatrixM3x3D m0,
                                                     MatrixM3x3D m1)

      Elementwise add of matrices `m0` and `m1`, returning the result in `m0`.
      Parameters:
        `m0` - The left input matrix.
        `m1` - The right input matrix.
      Returns:
        `m0`

    - #### addRowScaled

          public static final MatrixM3x3D addRowScaled(MatrixReadable3x3DType m,
                                                       int row_a,
                                                       int row_b,
                                                       int row_c,
                                                       double r,
                                                       MatrixM3x3D out)

      Add the values in row `row_b` to the values in row `row_a` scaled by `r`, saving the resulting row in row `row_c` of the matrix `out`.

      This is one of the three elementary operations defined on matrices.

      Parameters:
        `m` - The input matrix.
        `row_a` - The row on the lefthand side of the addition.
        `row_b` - The row on the righthand side of the addition.
        `row_c` - The destination row.
        `r` - The scaling value.
        `out` - The output matrix.
      Returns:
        `out`

    - #### addRowScaledInPlace

          public static final MatrixM3x3D addRowScaledInPlace(MatrixM3x3D m,
                                                              int row_a,
                                                              int row_b,
                                                              int row_c,
                                                              double r)

      Add the values in row `row_b` to the values in row `row_a` scaled by `r`, saving the resulting row in row `row_c` of the matrix `m`.

      This is one of the three elementary operations defined on matrices.

      Parameters:
        `m` - The input matrix.
        `row_a` - The row on the lefthand side of the addition.
        `row_b` - The row on the righthand side of the addition.
        `row_c` - The destination row.
        `r` - The scaling value.
      Returns:
        `m`

    - #### copy

          public static final MatrixM3x3D copy(MatrixReadable3x3DType input,
                                               MatrixM3x3D output)

      Copy the contents of the matrix `input` to the matrix `output`, completely replacing all elements.
      Parameters:
        `input` - The input vector.
        `output` - The output vector.
      Returns:
        `output`

    - #### determinant

          public static final double determinant(MatrixReadable3x3DType m)

      Calculate the determinant of the matrix `m`.
      Parameters:
        `m` - The input matrix.
      Returns:
        The determinant

    - #### doubleBuffer

          public static final DoubleBuffer doubleBuffer(MatrixM3x3D m)

      Parameters:
        `m` - The input matrix.
      Returns:
        A view of the buffer that backs this matrix.

    - #### exchangeRows

          public static final MatrixM3x3D exchangeRows(MatrixReadable3x3DType m,
                                                       int row_a,
                                                       int row_b,
                                                       MatrixM3x3D out)

      Exchange the row `row_a` and row `row_b` of the matrix `m`, saving the exchanged rows to `out`.

      This is one of the three elementary operations defined on matrices.

      Parameters:
        `m` - The input matrix.
        `row_a` - The first row.
        `row_b` - The second row.
        `out` - The output matrix.
      Returns:
        `out`

    - #### exchangeRowsInPlace

          public static final MatrixM3x3D exchangeRowsInPlace(MatrixM3x3D m,
                                                              int row_a,
                                                              int row_b)

      Exchange the row `row_a` and row `row_b` of the matrix `m`, saving the exchanged rows to `m`.

      This is one of the three elementary operations defined on matrices.

      Parameters:
        `m` - The input matrix.
        `row_a` - The first row.
        `row_b` - The second row.
      Returns:
        `m`

    - #### get

          public static final double get(MatrixReadable3x3DType m,
                                         int row,
                                         int column)

      Parameters:
        `m` - The matrix
        `row` - The row
        `column` - The column
      Returns:
        The value from the matrix `m` at row `row`, column `column`.

    - #### invert

          public static final com.io7m.jfunctional.OptionType<MatrixM3x3D> invert(MatrixReadable3x3DType m,
                                                                                  MatrixM3x3D out)

      Calculate the inverse of the matrix `m`, saving the resulting matrix to `out`. The function returns `Some(out)` iff it was possible to invert the matrix, and `None` otherwise. It is not possible to invert a matrix that has a determinant of `0`. If the function returns `None`, `m` is untouched.
      Parameters:
        `m` - The input matrix.
        `out` - The output matrix.
      Returns:
        `out`
      See Also:
        `determinant(MatrixReadable3x3DType)`

    - #### invertInPlace

          public static final com.io7m.jfunctional.OptionType<MatrixM3x3D> invertInPlace(MatrixM3x3D m)

      Calculate the inverse of the matrix `m`, saving the resulting matrix to `m`. The function returns `Some(m)` iff it was possible to invert the matrix, and `None` otherwise. It is not possible to invert a matrix that has a determinant of `0`. If the function returns `None`, `m` is untouched.
      Parameters:
        `m` - The input matrix.
      Returns:
        `m`
      See Also:
        `determinant(MatrixReadable3x3DType)`

    - #### lookAtWithContext

          public static final void lookAtWithContext(MatrixM3x3D.Context context,
                                                     VectorReadable3DType origin,
                                                     VectorReadable3DType target,
                                                     VectorReadable3DType up,
                                                     MatrixM3x3D out_matrix,
                                                     VectorM3D out_translation)

      Calculate a rotation and translation representing a "camera" looking from the point `origin` to the point `target`. `target` must represent the "up" vector for the camera. Usually, this is simply a unit vector `(0, 1, 0)` representing the Y axis.

      The function uses preallocated storage from `context`.

      The view is expressed as a rotation matrix and a translation vector, written to `out_matrix` and `out_translation`, respectively.

      Parameters:
        `context` - Preallocated storage
        `out_matrix` - The output matrix
        `out_translation` - The output translation
        `origin` - The position of the viewer
        `target` - The target being viewed
        `up` - The up vector

    - #### makeRotation

          public static final MatrixM3x3D makeRotation(double angle,
                                                       VectorReadable3DType axis)

      Generate and return a matrix that represents a rotation of `angle` radians around the axis `axis`.

      The function assumes a right-handed coordinate system and therefore a positive rotation around any axis represents a counter-clockwise rotation around that axis.

      Parameters:
        `angle` - The angle in radians.
        `axis` - The axis.
      Returns:
        A rotation matrix.
      Since:
        5.0.0

    - #### makeRotation

          public static final MatrixM3x3D makeRotation(double angle,
                                                       VectorReadable3DType axis,
                                                       MatrixM3x3D out)

      Generate a matrix that represents a rotation of `angle` radians around the axis `axis` and save to `out`.

      The function assumes a right-handed coordinate system and therefore a positive rotation around any axis represents a counter-clockwise rotation around that axis.

      Parameters:
        `angle` - The angle in radians.
        `axis` - The axis.
        `out` - The output matrix.
      Returns:
        `out`
      Since:
        5.0.0

    - #### makeTranslation2D

          public static final MatrixM3x3D makeTranslation2D(VectorReadable2DType v,
                                                            MatrixM3x3D out)

      Create a translation matrix that represents a translation by the vector `v`, writing the resulting matrix to `out`.
      Parameters:
        `v` - The translation vector.
        `out` - The output matrix.
      Returns:
        `out`

    - #### makeTranslation2I

          public static final MatrixM3x3D makeTranslation2I(VectorReadable2IType v,
                                                            MatrixM3x3D out)

      Create a translation matrix that represents a translation by the vector `v`, writing the resulting matrix to `out`.
      Parameters:
        `v` - The translation vector.
        `out` - The output matrix.
      Returns:
        `out`

    - #### multiply

          public static final MatrixM3x3D multiply(MatrixReadable3x3DType m0,
                                                   MatrixReadable3x3DType m1,
                                                   MatrixM3x3D out)

      Multiply the matrix `m0` with the matrix `m1`, writing the result to `out`.
      Parameters:
        `m0` - The left input vector.
        `m1` - The right input vector.
        `out` - The output vector.
      Returns:
        `out`

    - #### multiplyInPlace

          public static final MatrixM3x3D multiplyInPlace(MatrixM3x3D m0,
                                                          MatrixReadable3x3DType m1)

      Multiply the matrix `m0` with the matrix `m1`, writing the result to `m0`.
      Parameters:
        `m0` - The left input vector.
        `m1` - The right input vector.
      Returns:
        `out`

    - #### multiplyVector3D

          public static final VectorM3D multiplyVector3D(MatrixReadable3x3DType m,
                                                         VectorReadable3DType v,
                                                         VectorM3D out)

      Multiply the matrix `m` with the vector `v`, writing the resulting vector to `out`.
      Parameters:
        `m` - The input matrix.
        `v` - The input vector.
        `out` - The output vector.
      Returns:
        `out`

    - #### rotate

          public static final MatrixM3x3D rotate(double angle,
                                                 MatrixReadable3x3DType m,
                                                 VectorReadable3DType axis,
                                                 MatrixM3x3D out)

      Rotate the matrix `m` by `angle` radians around the axis `axis`, saving the result into `out`.
      Parameters:
        `angle` - The angle in radians.
        `m` - The input matrix.
        `axis` - A vector representing an axis.
        `out` - The output matrix.
      Returns:
        `out`
      Since:
        5.0.0

    - #### rotateInPlace

          public static final MatrixM3x3D rotateInPlace(double angle,
                                                        MatrixM3x3D m,
                                                        VectorReadable3DType axis)

      Rotate the matrix `m` by `angle` radians around the axis `axis`, saving the result into `m`.
      Parameters:
        `angle` - The angle in radians.
        `m` - The input matrix.
        `axis` - A vector representing an axis.
      Returns:
        `m`
      Since:
        5.0.0

    - #### rotateInPlaceWithContext

          public static final MatrixM3x3D rotateInPlaceWithContext(MatrixM3x3D.Context context,
                                                                   double angle,
                                                                   MatrixM3x3D m,
                                                                   VectorReadable3DType axis)

      Rotate the matrix `m` by `angle` radians around the axis `axis`, saving the result into `m`. The function uses preallocated storage in `context` to avoid allocating memory. The function assumes a right-handed coordinate system.
      Parameters:
        `context` - Preallocated storage.
        `angle` - The angle in radians.
        `m` - The input matrix.
        `axis` - A vector representing an axis.
      Returns:
        `m`
      Since:
        5.0.0

    - #### rotateWithContext

          public static final MatrixM3x3D rotateWithContext(MatrixM3x3D.Context context,
                                                            double angle,
                                                            MatrixReadable3x3DType m,
                                                            VectorReadable3DType axis,
                                                            MatrixM3x3D out)

      Rotate the matrix `m` by `angle` radians around the axis `axis`, saving the result into `out`. The function uses preallocated storage in `context` to avoid allocating memory. The function assumes a right-handed coordinate system.
      Parameters:
        `context` - Preallocated storage.
        `angle` - The angle in radians.
        `m` - The input matrix.
        `axis` - A vector representing an axis.
        `out` - The output matrix.
      Returns:
        `out`
      Since:
        5.0.0

    - #### row

          public static final VectorM3D row(MatrixReadable3x3DType m,
                                            int row,
                                            VectorM3D out)

      Parameters:
        `m` - The input matrix
        `row` - The row
        `out` - The output matrix
      Returns:
        Row `row` of the matrix `m` in the vector `out`.

    - #### scale

          public static final MatrixM3x3D scale(MatrixReadable3x3DType m,
                                                double r,
                                                MatrixM3x3D out)

      Scale all elements of the matrix `m` by the scaling value `r`, saving the result in `out`.
      Parameters:
        `m` - The input matrix.
        `r` - The scaling value.
        `out` - The output matrix.
      Returns:
        `out`

    - #### scaleInPlace

          public static final MatrixM3x3D scaleInPlace(MatrixM3x3D m,
                                                       double r)

      Scale all elements of the matrix `m` by the scaling value `r`, saving the result in `m`.
      Parameters:
        `m` - The input matrix.
        `r` - The scaling value.
      Returns:
        `m`

    - #### scaleRow

          public static final MatrixM3x3D scaleRow(MatrixReadable3x3DType m,
                                                   int row,
                                                   double r,
                                                   MatrixM3x3D out)

      Scale row `r` of the matrix `m` by `r`, saving the result to row `r` of `out`.

      This is one of the three elementary operations defined on matrices.

      Parameters:
        `m` - The input matrix.
        `row` - The index of the row `(0 <= row < 4)`.
        `r` - The scaling value.
        `out` - The output matrix.
      Returns:
        `out`

    - #### scaleRowInPlace

          public static final MatrixM3x3D scaleRowInPlace(MatrixM3x3D m,
                                                          int row,
                                                          double r)

      Scale row `r` of the matrix `m` by `r`, saving the result to row `r` of `m`.

      This is one of the three elementary operations defined on matrices.

      Parameters:
        `m` - The input matrix.
        `row` - The index of the row `(0 <= row < 4)`.
        `r` - The scaling value.
      Returns:
        `m`

    - #### set

          public static final MatrixM3x3D set(MatrixM3x3D m,
                                              int row,
                                              int column,
                                              double value)

      Set the value in the matrix `m` at row `row`, column `column` to `value`.
      Parameters:
        `m` - The matrix
        `row` - The row
        `column` - The column
        `value` - The value
      Returns:
        `m`

    - #### setIdentity

          public static final MatrixM3x3D setIdentity(MatrixM3x3D m)

      Set the given matrix `m` to the identity matrix.
      Parameters:
        `m` - The input matrix
      Returns:
        `m`

    - #### setZero

          public static final MatrixM3x3D setZero(MatrixM3x3D m)

      Set the given matrix `m` to the zero matrix.
      Parameters:
        `m` - The input matrix
      Returns:
        `m`

    - #### trace

          public static final double trace(MatrixReadable3x3DType m)

      Return the trace of the matrix `m`. The trace is defined as the sum of the diagonal elements of the matrix.
      Parameters:
        `m` - The input matrix
      Returns:
        The trace of the matrix
      Since:
        5.0.0

    - #### translateByVector2D

          public static final MatrixM3x3D translateByVector2D(MatrixReadable3x3DType m,
                                                              VectorReadable2DType v,
                                                              MatrixM3x3D out)

      Translate the matrix `m` by the vector `v`, storing the resulting matrix in `out`.
      Parameters:
        `m` - The input matrix.
        `v` - The translation vector.
        `out` - The output matrix.
      Returns:
        `out`

    - #### translateByVector2DInPlace

          public static final MatrixM3x3D translateByVector2DInPlace(MatrixM3x3D m,
                                                                     VectorReadable2DType v)

      Translate the matrix `m` by the vector `v`, storing the resulting matrix in `m`.
      Parameters:
        `m` - The input matrix.
        `v` - The translation vector.
      Returns:
        `m`

    - #### translateByVector2I

          public static final MatrixM3x3D translateByVector2I(MatrixReadable3x3DType m,
                                                              VectorReadable2IType v,
                                                              MatrixM3x3D out)

      Translate the matrix `m` by the vector `v`, storing the resulting matrix in `out`.
      Parameters:
        `m` - The input matrix.
        `v` - The translation vector.
        `out` - The output matrix.
      Returns:
        `out`

    - #### translateByVector2IInPlace

          public static final MatrixM3x3D translateByVector2IInPlace(MatrixM3x3D m,
                                                                     VectorReadable2IType v)

      Translate the matrix `m` by the vector `v`, storing the resulting matrix in `m`.
      Parameters:
        `m` - The input matrix.
        `v` - The translation vector.
      Returns:
        `m`

    - #### transpose

          public static final MatrixM3x3D transpose(MatrixReadable3x3DType m,
                                                    MatrixM3x3D out)

      Transpose the given matrix `m`, writing the resulting matrix to `out`.
      Parameters:
        `m` - The input matrix.
        `out` - The output matrix.
      Returns:
        `out`

    - #### transposeInPlace

          public static final MatrixM3x3D transposeInPlace(MatrixM3x3D m)

      Transpose the given matrix `m`, writing the resulting matrix to `m`.
      Parameters:
        `m` - The input matrix.
      Returns:
        `m`

    - #### equals

          public final boolean equals(@Nullable
                                      Object obj)

      Overrides:
        `equals` in class `Object`

    - #### get

          public final double get(int row,
                                  int column)

      Parameters:
        `row` - The row
        `column` - The column
      Returns:
        The value at the given row and column

    - #### getDoubleBuffer

          public final DoubleBuffer getDoubleBuffer()

      Specified by:
        `getDoubleBuffer` in interface `MatrixReadableDType`
      Returns:
        A view of the buffer that backs this matrix.

    - #### getRow3D

          public final void getRow3D(int row,
                                     VectorM3D out)

      Description copied from interface: `MatrixReadable3x3DType`
      Retrieve row `row`, saving the result to `out`.
      Specified by:
        `getRow3D` in interface `MatrixReadable3x3DType`
      Parameters:
        `row` - The index of the row, starting at `0`.
        `out` - The output vector.

    - #### getRowColumnD

          public final double getRowColumnD(int row,
                                            int column)

      Specified by:
        `getRowColumnD` in interface `MatrixReadableDType`
      Parameters:
        `row` - The row
        `column` - The column
      Returns:
        The value from the matrix at row `row` , column `column`.

    - #### hashCode

          public final int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### set

          public final MatrixM3x3D set(int row,
                                       int column,
                                       double value)

      Set the value at the given row and column.
      Parameters:
        `row` - The row
        `column` - The column
        `value` - The value
      Returns:
        `this`

    - #### toString

          public final String toString()

      Overrides:
        `toString` in class `Object`

Copyright © 2015 <code@io7m.com> http://io7m.com